﻿#define F_CPU			16000000
#define MORSE_SCURT		50
#define MORSE_PAUZA		50

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <string.h>
#include "usart.h"
//#include <SoftwareSerial.h>

//variabile globale
char buffer[100];
int length = 0;
int alarm = 0, count_digits = 0;
char secv[5] = {'8', '7', '7', '5'};
int tries = 0;
int SUCCES = 0;				//flag pentru cazul in care am apasat secventa corecta
char saved_password[4];
int length_password = 0;
int pass = 1;				//flag pentru cazul in care vrem sa setam o parola

void buzzer(int tip_morse) {
	int i;

	/* Alternam starea pinului PD4 la fiecare milisecunda. */
	for (i = 0; i < tip_morse; ++i) {
		PORTD ^= (1 << PD4);
		_delay_ms(1);
	}
}

void servomotor() {
	//PD5 output - OC1A este PD5
	DDRD |= (1 << PD5);
	//modul Fast PWM 8-bit, biții WGMn0 si WGMn2 au valoarea 1
	TCCR1A |= (1 << WGM10);
	//TCCR1A conține doar biții WGM10 si WGM11, WGM12 și WGM13 se găsesc in TCCR1B
	TCCR1B |= (1 << WGM12);
	//pentru modul non-inverting COM1A1 = 1 și COM1A0 = 0
	TCCR1A |= (1 << COM1A1);
	//pentru Prescaler de 8 scriem 1 pe CS12 si CS10
	TCCR1B |= (1 << CS11);
	//fill-rate 0.1: 1/10 din timp 1, restul din timp 0
	//OCR1A va fi 10 * 320 / 100
	OCR1A = 10 * 320 / 100;
}

void init() {
	/* Setam pinul 0 al portului C ca pin de iesire. */
	DDRC |= (1 << PC0);
	DDRC |= (1 << PC1);
	DDRC |= (1 << PC2);
	DDRC |= (1 << PC3);
	DDRC |= (1 << PC4);

	//sting ledul
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC4);

	// setam pinii de la 0-4 pentru iesire
	DDRA |= (1 << PA0);
	DDRA |= (1 << PA1);
	DDRA |= (1 << PA2);
	DDRA |= (1 << PA3);

	// setam pinii de la 0-3 pentru intrare -> coloane
	DDRB &= ~(1 << PB0);
	DDRB &= ~(1 << PB1);
	DDRB &= ~(1 << PB2);
	DDRB &= ~(1 << PB3);

	//BUZZER
	/* Setez pinul PD4 ca iesire. */
	DDRD |= (1 << PD4);
	/* Opresc buzzer-ul. */
	PORTD &= ~(1 << PD4);

	//SERVOMOTOR
	DDRD |= (1 << PD5);
	PORTD &= ~(1 << PD5);

	//GSM - setez PD0 si PD1 ca iesire
	DDRD |= (1 << PD0);
	DDRD |= (1 << PD1);

	//aprind ledul mare rosu care te avertizeaza sa introduci o parola
	PORTC |= (1 << PC4);
	buzzer(2500);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);
}

void do_column_one(int BTN_1, int BTN_4, int BTN_7, int BTN_STAR) {
	//COLOANA 1
	if((PINB & (1 << PB0)) == 1 && alarm == 0)
	{

		//enable pentru prima linie
		PORTA |= (1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '1'
		if((PINB & (1 << PB0)) == 1)
		{
			//daca are flag-ul de neapasat
			if(BTN_1 == 0) {
				//aprind ledul rosu
				PORTC |= (1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);
				_delay_ms(500);

				//sting ledul rosu
				PORTC &= ~(1 << PC0);

				//modificam flagul -> adica a fost apasat
				BTN_1 = 1;
			}
		}
		//daca a fost apasat, il facem neapasat si atunci crestem length
		if(BTN_1 == 1) {
			//daca vreau sa setez o parola
			if(pass == 1) {
				BTN_1 = 0;
				saved_password[length_password] = '1';
				length_password++;
			}
			//daca nu vreau sa setez parola
			else {
				BTN_1 = 0;
				buffer[length] = '1';
				length++;
			}
		}

		//enable pentru a doua linie
		PORTA &= ~(1 << PA0);
		PORTA |= (1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '4'
		if((PINB & (1 << PB0)) == 1)
		{
			//daca avem flag-ul de neapasat
			if(BTN_4 == 0) {
				//aprind ledul albastru
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC |= (1 << PC2);
				PORTC &= ~(1 << PC3);
				_delay_ms(500);

				//sting ledul albastru
				PORTC &= ~(1 << PC2);

				//modifcam flag-ul
				BTN_4 = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_4 == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_4 = 0;
					saved_password[length_password] = '2';
					length_password++;
				}
				else {
					BTN_4 = 0;
					buffer[length] = '4';
					length++;
				}
			}
		}

		//enable pentru linia a treia
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA |= (1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '7'
		if((PINB & (1 << PB0)) == 1)
		{
			//daca avem flag-ul pentru neapasat
			if(BTN_7 == 0) {
				//aprind ledul rosu, ledul verde si ledul albastru
				PORTC |= (1 << PC0);
				PORTC |= (1 << PC1);
				PORTC |= (1 << PC2);
				PORTC &= ~(1 << PC3);

				_delay_ms(500);

				//sting ledul rosu, ledul verde si ledul albastru
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);

				//modificam flag-ul
				BTN_7 = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_7 == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_7 = 0;
					saved_password[length_password] = '7';
					length_password++;
				}
				else {
					BTN_7 = 0;
					buffer[length] = '7';
					length++;
				}
			}
		}

		//enable pe ultima linie
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA |= (1 << PA3);
		_delay_ms(1);

		//este apasat butonul '*'
		if((PINB & (1 << PB0)) == 1)
		{
			//daca flagul este de neapasat
			if(BTN_STAR == 0) {
				//aprind ledul galben, ledul albastru si ledul verde
				PORTC &= ~(1 << PC0);
				PORTC |= (1 << PC1);
				PORTC |= (1 << PC2);
				PORTC |= (1 << PC3);

				_delay_ms(500);
				//sting ledul galben, ledul albastru si ledul verde
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);

				//modificam flag-ul
				BTN_STAR = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_STAR == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_STAR = 0;
					saved_password[length_password] = '*';
					length_password++;
				}
				else {
					BTN_STAR = 0;
					buffer[length] = '*';
					length++;
				}
			}
		}
	}
}

void do_column_two(int BTN_2, int BTN_5, int BTN_8, int BTN_0) {
	//COLOANA 2
	if((PINB & (1 << PB1)) == 2 && alarm == 0)
	{

		//enable pentru prima linie
		PORTA |= (1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '2'
		if((PINB & (1 << PB1)) == 2)
		{
			//daca flagul este de neapasat
			if(BTN_2 == 0) {
				//aprind ledul verde
				PORTC &= ~(1 << PC0);
				PORTC |= (1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);
				_delay_ms(500);

				//sting ledul verde
				PORTC &= ~(1 << PC1);

				//modific flag-ul
				BTN_2 = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_2 == 1) {
				//daca vrem sa setam o parola
				if(pass == 1) {
					BTN_2 = 0;
					saved_password[length_password] = '2';
					length_password++;
				}
				else {
					BTN_2 = 0;
					buffer[length] = '2';
					length++;
				}
			}
		}

		//enable pentru a doua linie
		PORTA &= ~(1 << PA0);
		PORTA |= (1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '5'
		if((PINB & (1 << PB1)) == 2)
		{
			//daca flagul este de neapasat
			if(BTN_5 == 0) {
				//aprind ledul rosu si ledul albastru
				PORTC |= (1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC |= (1 << PC2);
				PORTC &= ~(1 << PC3);
				_delay_ms(500);

				//sting ledul rosu si ledul albastru
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC2);
				
				//modific flagul
				BTN_5 = 1;
			}

			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_5 == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_5 = 0;
					saved_password[length_password] = '5';
					length_password++;
				}
				else {
					BTN_5 = 0;
					buffer[length] = '5';
					length++;
				}
			}
		}

		//enable pentru linia a treia
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA |= (1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '8'
		if((PINB & (1 << PB1)) == 2)
		{
			//daca flagul este de neapasat
			if(BTN_8 == 0) {
				//aprind ledul albastru
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC |= (1 << PC3);

				_delay_ms(500);

				//sting ledul albastru
				PORTC &= ~(1 << PC3);
				
				//modific flagul
				BTN_8 = 1;
			}

			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_8 == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_8 = 0;
					saved_password[length_password] = '8';
					length_password++;
				}
				else {
					BTN_8 = 0;
					buffer[length] = '8';
					length++;
				}
			}
		}

		//enable pe ultima linie
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA |= (1 << PA3);
		_delay_ms(1);

		//este apasat butonul '0' -> aprind ledul care este in plus
		if((PINB & (1 << PB1)) == 2)
		{
			//daca flagul este de neapasat
			if(BTN_0 == 0) {
				//aprind ledul rosu in plus
				PORTC |= (1 << PC4);

				_delay_ms(500);
				//sting ledul rosu in plus
				PORTC &= ~(1 << PC4);
				
				//modific flagul
				BTN_0 = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_0 == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_0 = 0;
					saved_password[length_password] = '0';
					length_password++;
				}
				else {
					BTN_0 = 0;
					buffer[length] = '0';
					length++;
				}
			}
		}
	}
}

void do_column_three(int BTN_3, int BTN_6, int BTN_9, int BTN_HASH) {
	//COLOANA 3
	if((PINB & (1 << PB2)) == 4 && alarm == 0)
	{

		//enable pentru prima linie
		PORTA |= (1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '3'
		if((PINB & (1 << PB2)) == 4)
		{
			//daca flagul este de neapasat
			if(BTN_3 == 0) {
				//aprind ledul rosu si ledul verde
				PORTC |= (1 << PC0);
				PORTC |= (1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);
				_delay_ms(500);

				//sting ledul rosu si ledul verde
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);

				//modific flagul
				BTN_3 = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_3 == 1) {
				//daca vreau sa setez o parola
				if(pass	== 1) {
					BTN_3 = 0;
					saved_password[length_password] = '3';
					length_password++;
				}
				else {
					BTN_3 = 0;
					buffer[length] = '3';
					length++;
				}
			}
		}

		//enable pentru a doua linie
		PORTA &= ~(1 << PA0);
		PORTA |= (1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '6'
		if((PINB & (1 << PB2)) == 4)
		{
			//daca flagul este de neapasat
			if(BTN_6 == 0) {
				//aprind ledul verde si ledul albastru
				PORTC &= ~(1 << PC0);
				PORTC |= (1 << PC1);
				PORTC |= (1 << PC2);
				PORTC &= ~(1 << PC3);
				_delay_ms(500);

				//sting ledul verde si ledul albastru
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);
				
				//modific flagul
				BTN_6 = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_6 == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_6 = 0;
					saved_password[length_password] = '6';
					length_password++;
				}
				else {
					BTN_6 = 0;
					buffer[length] = '6';
					length++;
				}
			}
		}

		//enable pentru linia a treia
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA |= (1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul '9'
		if((PINB & (1 << PB2)) == 4)
		{
			//daca flagul este de neapasat
			if(BTN_9 == 0) {
				//aprind ledul rosu si ledul galben
				PORTC |= (1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC |= (1 << PC3);

				_delay_ms(500);

				//sting ledul rosu si ledul galben
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC3);

				//modific flagul
				BTN_9 = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_9 == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_9 = 0;
					saved_password[length_password] = '9';
					length_password++;
				}
				else {
					BTN_9 = 0;
					buffer[length] = '9';
					length++;
				}
			}
		}

		//enable pe ultima linie
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA |= (1 << PA3);
		_delay_ms(1);

		//este apasat butonul '#' -> afisez 15
		if((PINB & (1 << PB2)) == 4)
		{
			//daca flagul este de neapasat
			if(BTN_HASH == 0) {
				//aprind toate ledurile
				PORTC |= (1 << PC0);
				PORTC |= (1 << PC1);
				PORTC |= (1 << PC2);
				PORTC |= (1 << PC3);

				_delay_ms(500);
				//sting toate ledurile
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);

				//modific flagul
				BTN_HASH = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_HASH == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_HASH = 0;
					saved_password[length_password] = '#';
					length_password++;
				}
				else {
					BTN_HASH= 0;
					buffer[length] = '#';
					length++;
				}
			}
		}
	}
}

void do_column_four(int BTN_A, int BTN_B, int BTN_C, int BTN_D) {
	//COLOANA 4
	if((PINB & (1 << PB3)) == 8 && alarm == 0)
	{

		//enable pentru prima linie
		PORTA |= (1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul 'A' -> afisez 10
		if((PINB & (1 << PB3)) == 8)
		{
			//daca flagul este de neapasat
			if(BTN_A == 0) {
				//aprind ledul galben si ledul verde
				PORTC &= ~(1 << PC0);
				PORTC |= (1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC |= (1 << PC3);
				_delay_ms(500);

				//sting ledul galben si ledul verde
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC3);

				//modific flagul
				BTN_A = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_A == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_A = 0;
					saved_password[length_password] = 'A';
					length_password++;
				}
				else {
					BTN_A = 0;
					buffer[length] = 'A';
					length++;
				}
			}
		}

		//enable pentru a doua linie
		PORTA &= ~(1 << PA0);
		PORTA |= (1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul 'B' -> afisez 11
		if((PINB & (1 << PB3)) == 8)
		{
			//daca flagul este de neapasat
			if(BTN_B == 0) {
				//aprind ledul rosu, ledul verde si ledul galben
				PORTC |= (1 << PC0);
				PORTC |= (1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC |= (1 << PC3);
				_delay_ms(500);

				//sting ledul rosu, ledul verde si ledul galben
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC3);

				//modificam flagul
				BTN_B = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_B == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_B = 0;
					saved_password[length_password] = 'B';
					length_password++;
				}
				else {
					BTN_B = 0;
					buffer[length] = 'B';
					length++;
				}
			}
		}

		//enable pentru linia a treia
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA |= (1 << PA2);
		PORTA &= ~(1 << PA3);
		_delay_ms(1);

		//este apasat butonul 'C' -> afisez 12
		if((PINB & (1 << PB3)) == 8)
		{
			//daca flagul este de neapasat
			if(BTN_C == 0) {
				//aprind ledul galben si ledul albastru
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC |= (1 << PC2);
				PORTC |= (1 << PC3);

				_delay_ms(500);

				//sting ledul galben si ledul albastru
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);

				//modificam flagul
				BTN_C = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_C == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_C = 0;
					saved_password[length_password] = 'C';
					length_password++;
				}
				else {
					BTN_C = 0;
					buffer[length] = 'C';
					length++;
				}	
			}
		}

		//enable pe ultima linie
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA |= (1 << PA3);
		_delay_ms(1);

		//este apasat butonul 'D' -> afisez 13
		if((PINB & (1 << PB3)) == 8)
		{
			//daca flagul este de neapasat
			if(BTN_D == 0) {
				//aprind ledul galben, ledul albastru si ledul rosu
				PORTC |= (1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC |= (1 << PC2);
				PORTC |= (1 << PC3);

				_delay_ms(500);
				//sting ledul galben, ledul albastru si ledul rosu
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);

				//modific flagul
				BTN_D = 1;
			}
			//daca a fost apasat, il facem neapasat si atunci crestem length
			if(BTN_D == 1) {
				//daca vreau sa setez o parola
				if(pass == 1) {
					BTN_D = 0;
					saved_password[length_password] = 'D';
					length_password++;
				}
				else {
					BTN_D = 0;
					buffer[length] = 'D';
					length++;
				}
			}
		}
	}
}

void check_password() {

	int i;
	//doar daca am apasat o secventa de 4 butoane
	if(length == 4) {
		count_digits = 0;
		//verific daca este aceeasi secventa
		for(i = 0; i < length; i ++) {
			if(buffer[i] == saved_password[i]) {
				count_digits++;
			}
		}

		if(count_digits == 4) {
			// sting si aprind ledul
			PORTC ^= (1 << PC3);
			_delay_ms(200);
			//setez flag-ul pentru ca s-a introdus secventa corecta
			SUCCES = 1;
			//resetez numarul de incercari la 0
			tries = 0;
		}
		//daca a fost introdus un cod gresit, atunci se aude buzzer-ul
		if(SUCCES == 0) {
			tries++;
			length = 0;
		}
		else if(SUCCES == 1) {
			servomotor();
		}
	}
	//daca parola a fost introdusa gresit de 3 ori, porneste buzzer-ul
	if(tries == 3) {
		//PENTRU BUZZER
		buzzer(MORSE_SCURT);
		//PORTD &= ~(1 << PD4);
		_delay_ms(MORSE_PAUZA);
		alarm = 1;
	}
}

int main() {

	init();
	
	//flag-uri pentru butoane pentru a vedea daca au fost sau nu apasate
	int BTN_0 = 0, BTN_1 = 0, BTN_2 = 0, BTN_3 = 0,
		BTN_4 = 0, BTN_5 = 0, BTN_6 = 0, BTN_7 = 0,
		BTN_8 = 0, BTN_9 = 0, BTN_A = 0, BTN_B = 0,
		BTN_C = 0, BTN_D = 0, BTN_STAR = 0, BTN_HASH = 0;
	
	int set_password = 0;
	while (1) {

		//enable pentru toate liniile de pe tastatura
		PORTA |= (1 << PA0);
		PORTA |= (1 << PA1);
		PORTA |= (1 << PA2);
		PORTA |= (1 << PA3);

		if(set_password == 0) {
			pass = 1;
			do_column_one(BTN_1, BTN_4, BTN_7, BTN_STAR);
			do_column_two(BTN_2, BTN_5, BTN_8, BTN_0);
			do_column_three(BTN_3, BTN_6, BTN_9, BTN_HASH);
			do_column_four(BTN_A, BTN_B, BTN_C, BTN_D);
		}

		if(length_password == 4) {
			PORTC |= (1 << PC4);
			set_password = 1;
		}

		if(set_password == 1) {
			//inca un sunet ca ti-ai setat parola
			//buzzer_morse(2500);
			//PORTD &= ~(1 << PD5);
			PORTC |= (1 << PC4);
			_delay_ms(50);
			PORTC &= ~(1 << PC4);
			pass = 0;
			do_column_one(BTN_1, BTN_4, BTN_7, BTN_STAR);
			do_column_two(BTN_2, BTN_5, BTN_8, BTN_0);
			do_column_three(BTN_3, BTN_6, BTN_9, BTN_HASH);
			do_column_four(BTN_A, BTN_B, BTN_C, BTN_D);
			check_password();
		}
	}

	return 0;
}